// DataCollectionComponent.cpp: implementation of the CDataCollectionComponent class.
//
//////////////////////////////////////////////////////////////////////

#include "DataCollectionComponent.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDataCollectionComponent::CDataCollectionComponent(string sLabel, int nNumberOfDevices, int nNetAddress):CDestinationComponent(sLabel, nNumberOfDevices, nNetAddress)
{
	m_oEth.resize(nNumberOfDevices);
	m_nNumberOfDevices = nNumberOfDevices;
	for (int i = 0; i < nNumberOfDevices; i++)
	{
		m_oEth[i].ConnectToSystem(&m_oEthSink,0);	
		m_oEth[i].SetParentLabel(m_sLabel);
		m_oEth[i].SetParentAddress(m_nNetAddress);
		m_oEth[i].SetLabel("Eth" + str(i));
	}
}

CDataCollectionComponent::~CDataCollectionComponent()
{

}
void CDataCollectionComponent::Report()
{
	m_oEthSink.Report();
}

void CDataCollectionComponent::Go()
{
	CComponent::Go();
	m_oEthSink.Go();
}
	

