// DataCollectionSink.h: interface for the CDataCollectionSink class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATACOLLECTIONSINK_H__C60B312C_8EBE_42AE_9375_46CA0F8267E3__INCLUDED_)
#define AFX_DATACOLLECTIONSINK_H__C60B312C_8EBE_42AE_9375_46CA0F8267E3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PacketSink.h"
#include <vector>

class CDataCollectionSink : public CPacketSink  
{
public:
	CDataCollectionSink(string sLabel = "Unlabeled", int nTime = 0);
	virtual ~CDataCollectionSink();
	bool AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel);

	double PercentileProcessingTime(int nClass);
	double PercentileTotalTime(int nClass);
	double PercentileQueueTime(int nClass);
	double AverageTimeInSystem(int nClass);
	double AverageTimeInQueue(int nClass);
	double AverageProcessingTime(int nClass);
	void CalculateTotals();
	int TotalRequestsProcessed(int nClass);
	int TotalProcessed();
	int TotalSizeProcesed(int nClass);
	void Report();
	void Go();
	
protected:
	vector<CPacket*> m_vProcessedClassZero;		
	vector<CPacket*> m_vProcessedClassOne;	
	vector<CPacket*> m_vProcessedClassTwo;	
	vector<CPacket*> m_vProcessedClassThree;
	vector<CPacket*> m_vProcessedClassFour;

	double averageVectorTimeInSystem(vector<CPacket*> &vRequests);
	double averageVectorTimeInQueue(vector<CPacket*> &vRequests);
	double averageVectorProcessingTime(vector<CPacket*> &vRequests);
	double percentileVectorProcessingTime(vector<CPacket*> &vRequests);
	double percentileVectorTotalTime(vector<CPacket*> &vRequests);
	double percentileVectorQueueTime(vector<CPacket*> &vRequests);

	void SortByProcessingTime(int nClass);
	void SortByQueueTime(int nClass);
	void SortByTotalTime(int nClass);
	void sortVectorByTotalTime(vector<CPacket*> &vRequests);
	void sortVectorByQueueTime(vector<CPacket*> &vRequests);
	void sortVectorByProcessingTime(vector<CPacket*> &vRequests);

	int m_nTotalProcessed;
	int m_nRejectedClassZero;
	int m_nRejectedClassOne;
	int m_nRejectedClassTwo;
	int m_nRejectedClassThree;
	int m_nRejectedClassFour;

};

#endif // !defined(AFX_DATACOLLECTIONSINK_H__C60B312C_8EBE_42AE_9375_46CA0F8267E3__INCLUDED_)
