// DestinationComponent.cpp: implementation of the CDestinationComponent class.
//
//////////////////////////////////////////////////////////////////////

#include "DestinationComponent.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDestinationComponent::CDestinationComponent(string sLabel, int nNumberOfDevices, int nNetAddress) :CComponent(sLabel, nNetAddress)
{
	m_oEth.resize(nNumberOfDevices);
	m_nNumberOfDevices = nNumberOfDevices;
	for (int i = 0; i < nNumberOfDevices; i++)
	{
		m_oEth[i].ConnectToSystem(&m_oEthSink,0);	
		m_oEth[i].SetParentLabel(m_sLabel);
		m_oEth[i].SetParentAddress(m_nNetAddress);
		m_oEth[i].SetLabel("Eth" + str(i));
	}
	
}

CDestinationComponent::~CDestinationComponent()
{

}

bool CDestinationComponent::LinkToDevice(CLink* pLink, int nDevice)
{
	if (nDevice < m_nNumberOfDevices)
	{
		return pLink->ConnectToDevice(&m_oEth[nDevice], 0);
	}
	else
	{
		LOG("CDestinationComponent::LinkToDevice");
		return false;
	}
}

