// DropTailQueue.cpp: implementation of the CDropTailQueue class.
//
//////////////////////////////////////////////////////////////////////

#include "DropTailQueue.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDropTailQueue::CDropTailQueue(int nCapacity)
{
	m_nQueueCapacity = nCapacity;
	m_nCurrentUtilization = 0;

}

CDropTailQueue::~CDropTailQueue()
{

}

bool CDropTailQueue::AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel)
{
	
	if (nConnectionLabel == 0)
	{
		if (!QueueFull())
		{
			m_PacketQueue.AddTail(pIncommingPacket);
			m_nCurrentUtilization += pIncommingPacket->PacketSize();
			return true;
		}
		else
		{
			m_oPacketSink.Push(pIncommingPacket);
			return true;
		}
	}
	else
	{
		LOG("CDropTailQueue::AcceptPacket");
		return false;
	}
}

CPacket* CDropTailQueue::GetPacket(int nConnectionLabel)
{
	CPacket* pReturnPacket = NULL;
	if (!m_PacketQueue.IsEmpty())
	{
		pReturnPacket = m_PacketQueue.GetHead();
		m_PacketQueue.RemoveHead();
		m_nCurrentUtilization -= pReturnPacket->PacketSize();
	}
	return pReturnPacket;
}

bool CDropTailQueue::QueueFull()
{
	return (m_nQueueCapacity <= m_nCurrentUtilization);
}


bool CDropTailQueue::ConnectToSink(CElement* pElement, int nLabel)
{
	return m_oPacketSink.SetConnection(pElement, nLabel);
}

int CDropTailQueue::BackPressure()
{
	double nPressure = 0.0;
	if (m_nCurrentUtilization > 0)
	{
		nPressure = ((m_nCurrentUtilization / m_nQueueCapacity) * 100.00);
		return (int)nPressure;
	}
	else
	{
		return 0;
	}

}

void CDropTailQueue::SetCapacity(int nCapacity)
{
	m_nQueueCapacity = nCapacity;
}

bool CDropTailQueue::Done()
{
	return m_PacketQueue.IsEmpty();
}