// Link.cpp: implementation of the CLink class.
//
//////////////////////////////////////////////////////////////////////

#include "Link.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLink::CLink(int nConnectionSpeed)
{
	m_nConnectionSpeed = nConnectionSpeed;
}

CLink::~CLink()
{

}

//////////////////////////////////////////////////////////////////////
// Activate Link
//////////////////////////////////////////////////////////////////////

void CLink::Go()
{
	m_pFromDevice->ProcessBytes(m_nConnectionSpeed);
}

//////////////////////////////////////////////////////////////////////
// Set member variables
//////////////////////////////////////////////////////////////////////

bool CLink::ConnectToDevice(CElement* pElement, int nLabel)
{
	return m_oToDevice.SetConnection(pElement, nLabel);
}

void CLink::ConnectFromDevice(CEthernetDevice* pFromDevice)
{
	m_pFromDevice = pFromDevice;
}

void CLink::SetConnectionSpeed(int nNewSpeed)
{
	if (nNewSpeed > 0)
	{
		m_nConnectionSpeed = nNewSpeed;
	}
}

//////////////////////////////////////////////////////////////////////
// Get member variables
//////////////////////////////////////////////////////////////////////

int CLink::ConnectionSpeed()
{
	return m_nConnectionSpeed;
}

/////////////////////////////////////////////////////////////////////
// Virtual Function implementation 
/////////////////////////////////////////////////////////////////////

bool CLink::AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel)
{
	if (nConnectionLabel == 0) //Packet pushed on to device from FromDevice
	{
		pIncommingPacket->ResetProcessingRequirement();
		return m_oToDevice.Push(pIncommingPacket);
	}
	else
	{
		LOG("CLink::AcceptPacket");
		return false; //This Element has no other push connections
	}
}

