// Link.h: interface for the CLink class.
//
//
//
//                        _________________                            
//     FROM     Push --->|0               1|---> Push     TO          
//    DEVICE             |     Link        |            DEVICE        
//                       |                 |                         
//                       |_________________|                          
//                                                                    
//                                                            
//                                                                    
//                                                                    
//                                                                     
//                                                                      
//                                                                         
//////////////////////////////////////////////////////////////////////

#if !defined(LINK_H)
#define LINK_H

#include "Element.h"
#include "EthernetDevice.h"

class CLink : public CElement  
{
public:
	CLink(int nConnectionSpeed = 500);
	virtual ~CLink();

	//Activate Link
	void Go();

	//Set member variables
	virtual bool ConnectToDevice(CElement* pElement, int nLabel);
	virtual void ConnectFromDevice(CEthernetDevice* pFromDevice);
	void SetConnectionSpeed(int nNewSpeed);

	//Get member variables
	int ConnectionSpeed();

	//Virtual Function implementation 
	bool AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel);
	
protected:
	CPushConnection m_oToDevice;
	CEthernetDevice* m_pFromDevice;
	int m_nConnectionSpeed;


};

#endif // !defined(AFX_LINK_H__9531E053_26D3_417E_A1C2_E7324888F08F__INCLUDED_)
