// PacketClassifier.cpp: implementation of the CPacketClassifier class.
//
//////////////////////////////////////////////////////////////////////

#include "PacketClassifier.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPacketClassifier::CPacketClassifier(int nNumOfClasses)
{
	m_vClassifiedConnections.resize(nNumOfClasses);
	for (int i = 0; i < nNumOfClasses; i++)
	{
		CPushConnection* nNewConnection = new CPushConnection;
		m_vClassifiedConnections[i] = nNewConnection;
	}
	m_nNumberOfClasses = nNumOfClasses;
}

CPacketClassifier::~CPacketClassifier()
{

}

bool CPacketClassifier::ConnectToClass(CElement* pElement, int nLabel, int nClassNum)
{
	if ((nClassNum >= 0) && (nClassNum <= m_nNumberOfClasses))
	{
		return m_vClassifiedConnections[nClassNum]->SetConnection(pElement, nLabel);
	}
	else
	{
		LOG("CPacketClassifier::ConnectToClass");
		return false;
	}
}

bool CPacketClassifier::AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel)
{
	int nPacketClass = pIncommingPacket->PriorityClass();

	if (nConnectionLabel == 0) //Packet pushed on to device from network
	{
		if ((nPacketClass >= 0) && (nPacketClass <= m_nNumberOfClasses))
		{
			return m_vClassifiedConnections[nPacketClass]->Push(pIncommingPacket);
		}
		else
		{
			return m_vClassifiedConnections[0]->Push(pIncommingPacket);
		}
	}
	else
	{
		LOG("CPacketClassifier::AcceptPacket");
		return false; //This Element has no other push connections
	}
}

void CPacketClassifier::SetNumberOfClasses(int nNumberOfClasses)
{
	/*for (int i = 0; i < m_vClassifiedConnections.size()-1; i++)
	{
		delete m_vClassifiedConnections[i];
	}*/
	m_vClassifiedConnections.resize(nNumberOfClasses);
	for (int i = 0; i < nNumberOfClasses; i++)
	{
		CPushConnection* nNewConnection = new CPushConnection;
		m_vClassifiedConnections[i] = nNewConnection;
	}
	m_nNumberOfClasses = nNumberOfClasses;
}
