// PacketClassifier.h: interface for the CPacketClassifier class.
//
//                                 Push
//                                  |
//                                  | 
//                        __________V____________                            
//                       |          0            |
//                       |   PacketClassifier    |
//                       |                       |
//                       |_1____2____3____4____n_| 
//                         |    |    |    |    |
//                         |    |    |    |    |
//                         V    V    V    V    V
//                        Push Push Push Push Push
//                         C1   C2   C3   C4   Cn
//////////////////////////////////////////////////////////////////////

#if !defined(PACKETCLASSIFIER_H)
#define PACKETCLASSIFIER_H

#include "Element.h"
#include "PushConnection.h"
#include "Packet.h"
#include <vector>

class CPacketClassifier : public CElement  
{
public:
	CPacketClassifier(int nNumOfClasses = 3);
	virtual ~CPacketClassifier();
	bool ConnectToClass(CElement* pElement, int nLabel, int nClassNum);
	bool AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel);
	void SetNumberOfClasses(int nNumberOfClasses);

protected:

	vector<CPushConnection*> m_vClassifiedConnections;
	int m_nNumberOfClasses;

};

#endif
