// PacketGenerator.h: interface for the CPacketGenerator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(PACKETGENERATOR_H)
#define PACKETGENERATOR_H

#include "Element.h"
#include "PushConnection.h"
#include "Packet.h"
#include "Link.h"
#include <time.h>
#include <math.h>
#include <gsl\gsl_rng.h>
#include <gsl\gsl_randist.h>

class CPacketGenerator : public CLink  
{
public:
	CPacketGenerator(int nAverageSize = 50, int nPacketsPerInterval = 1000, int nTimeRemaining = 200);
	virtual ~CPacketGenerator();

	
	//Access member variables
	void SetAveragePacketSize(int nAverageSize);
	void SetPacketsPerInterval(int nAverageSize);
	int AveragePacketSize();
	int PacketsPerInterval();

	//Set connection
	bool ConnectToDevice(CElement* pElement, int nLabel);

	//Activate Generator
	void Go();
	bool Done();

protected:

	int m_nAveragePacketSize;
	int m_nPacketsPerInterval;
	int m_nLocalTime;
	int m_nTimeRemaining;

	CPushConnection m_oToDevice;

};

#endif // !defined(AFX_PACKETGENERATOR_H__C53DDBF7_B9E2_464C_A198_B9B30F58009A__INCLUDED_)
