// MultiPathRoutingTable.cpp: implementation of the CMultiPathRoutingTable class.
//
//////////////////////////////////////////////////////////////////////

#include "RRMultiPathRoutingTable.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRRMultiPathRoutingTable::CRRMultiPathRoutingTable()
{

}

CRRMultiPathRoutingTable::~CRRMultiPathRoutingTable()
{

}

int CRRMultiPathRoutingTable::GetDevice(int nDestination)
{
	CRoute oRoute;
	oRoute.nOutputDevice = 0;
	int nLastPriority = GetLastPriority(nDestination);
	
	
	//Reset the routing table
	m_oRoutingTable.MoveFirst();

	//Search for the next route
	while (!m_oRoutingTable.EOL())
	{
		oRoute = m_oRoutingTable.GetNext();
		if ((oRoute.nDestination == nDestination) && oRoute.nPriority == (nLastPriority + 1))
		{
			setLastPriority(oRoute);
			return oRoute.nOutputDevice;
		}
	}

	//Else, search for the first priority route
	//Reset the routing table
	m_oRoutingTable.MoveFirst();

	//Search for the next route
	while (!m_oRoutingTable.EOL())
	{
		oRoute = m_oRoutingTable.GetNext();
		if ((oRoute.nDestination == nDestination) && oRoute.nPriority == (0))
		{
			setLastPriority(oRoute);
			return oRoute.nOutputDevice;
		}
	}

	//Else, return bad route
	return -1;
}

void CRRMultiPathRoutingTable::SetRoute(int nDestination, int nDevice, int nPriority)
{
	CRoute oRoute;
	oRoute.nDestination  = nDestination;
	oRoute.nOutputDevice = nDevice;
	oRoute.nPriority     = nPriority;

	m_oRoutingTable.MoveFirst();
	while (!m_oRoutingTable.EOL())
	{
		if ((oRoute.nDestination == m_oRoutingTable.GetNext().nDestination) &&
			(oRoute.nPriority    == m_oRoutingTable.GetCurrent().nPriority))
		{
			m_oRoutingTable.RemoveCurrent();
			break;
		}
	}
	m_oRoutingTable.AddTail(oRoute);
}

int CRRMultiPathRoutingTable::GetLastPriority(int nDestination)
{
	CRoute oRoute;
	oRoute.nDestination  = nDestination;
	m_oRoutingHistory.MoveFirst();
	while (!m_oRoutingHistory.EOL())
	{
		if ((oRoute.nDestination == m_oRoutingHistory.GetNext().nDestination))
		{
			return m_oRoutingHistory.GetCurrent().nPriority;
		}
	}
	return -1;
}

void CRRMultiPathRoutingTable::setLastPriority(CRoute oRoute)
{
	m_oRoutingHistory.MoveFirst();
	while (!m_oRoutingHistory.EOL())
	{
		if (oRoute.nDestination == m_oRoutingHistory.GetNext().nDestination)
		{
			m_oRoutingHistory.RemoveCurrent();
			break;
		}
	}
	m_oRoutingHistory.AddTail(oRoute);
}
