// RouteSelector.h: interface for the CRouteSelector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(ROUTESELECTOR_H)
#define ROUTESELECTOR_H

#include "Element.h"
#include <vector>
#include "PushConnection.h"
#include "SimpleRoutingTable.h"
#include "RRMultiPathRoutingtable.h"
#include "SelectiveMultiPathRoutingTable.h"
#include "DropTailQueue.h"

class CRouteSelector : public CElement  
{
public:
	CRouteSelector(int nNumOfDevices = 3, int nType = 0);
	virtual ~CRouteSelector();
	bool ConnectToSink(CElement* pElement, int nLabel);
	bool ConnectToDevice(CElement* pElement, int nLabel, int nDevice);
	bool AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel);
	void SetRoute(int nDestination, int nDevice, int nPriority = 0);
	void SetPressureLimit(int nDevice, int nLimit);
	void SetNumberOfDevices(int nNumberOfDevices);
	void SetType(int nType);


protected:
	CSimpleRoutingTable m_oSimpleRoutingTable;
	CRRMultiPathRoutingTable m_oRRMultiPathRoutingTable;
	CSelectiveMultiPathRoutingTable m_oSelectiveMultiPathRoutingTable;
	vector<CPushConnection*> m_vConnectedDevices;
	vector<int> m_vPressureLimits;
	int m_nNumOfDevices;
	CPushConnection m_oBadRouteSink;
	int m_nType;
	bool tooMuchPressure(int nDevice);
	

};

#endif // !defined(AFX_ROUTESELECTOR_H__BBD3C59B_8D5C_4439_9AA4_FED1B37A4B2F__INCLUDED_)
