// SinglePathRouter.h: interface for the CSinglePathRouter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(ROUTER_H)
#define SINGLEPATHROUTER_H

#include "StoreAndForwardRepeater.h"
#include "RouteSelector.h"

class CRouter : public CStoreAndForwardRepeater  
{
public:
	CRouter(string sLabel = "Unlabeled", int nNumberOfDevices = 5, int nType = 0, int nNetAddress = -1);
	virtual ~CRouter();

	bool LinkToDevice(CLink* pLink, int nDevice);
	bool LinkFromDevice(CLink* pLink, int nDevice);
	void SetRoute(int nDestination, int nDevice, int nPriority = 0);
	void SetPressureLimit(int nDevice, int nLimit);
	void Report();
	
protected:

	int m_nNumberOfDevices;
	vector<CEthernetDevice> m_oEth;
	vector<CDropTailQueue>  m_oEthQueue;
	vector<CPacketSink>     m_oEthSink;
	CRouteSelector  m_oRouteSelector;
	CPacketSink		m_oBadRouteSink;
	int m_nType;
	

};

#endif 
