// SelectiveMultiPathRoutingTable.cpp: implementation of the CSelectiveMultiPathRoutingTable class.
//
//////////////////////////////////////////////////////////////////////

#include "SelectiveMultiPathRoutingTable.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSelectiveMultiPathRoutingTable::CSelectiveMultiPathRoutingTable()
{

}

CSelectiveMultiPathRoutingTable::~CSelectiveMultiPathRoutingTable()
{

}

void CSelectiveMultiPathRoutingTable::SetRoute(int nDestination, int nDevice, int nPriority)
{
	CRoute oRoute;
	oRoute.nDestination  = nDestination;
	oRoute.nOutputDevice = nDevice;
	oRoute.nPriority     = nPriority;

	m_oRoutingTable.MoveFirst();
	while (!m_oRoutingTable.EOL())
	{
		if ((oRoute.nDestination == m_oRoutingTable.GetNext().nDestination) &&
			(oRoute.nPriority    == m_oRoutingTable.GetCurrent().nPriority))
		{
			m_oRoutingTable.RemoveCurrent();
			break;
		}
	}
	m_oRoutingTable.AddTail(oRoute);
}

CRoute CSelectiveMultiPathRoutingTable::GetDevice(int nDestination, int nPriority)
{
	CRoute oRoute;
	oRoute.nOutputDevice = 0;
	int nLastPriority = -1;
	
	
	//Reset the routing table
	m_oRoutingTable.MoveFirst();

	//Search for the next route
	while (!m_oRoutingTable.EOL())
	{
		oRoute = m_oRoutingTable.GetNext();
		if ((oRoute.nDestination == nDestination) && (oRoute.nPriority == nPriority))
		{
			return oRoute;
		}
	}

	nPriority = 0;
	while (!m_oRoutingTable.EOL())
	{
		oRoute = m_oRoutingTable.GetNext();
		if ((oRoute.nDestination == nDestination) && (oRoute.nPriority == nPriority))
		{
			return oRoute;
		}
	}
	
	oRoute.nPriority = -1;
	return oRoute;
}
