// SimpleRoutingTable.cpp: implementation of the CSimpleRoutingTable class.
//
//////////////////////////////////////////////////////////////////////

#include "SimpleRoutingTable.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSimpleRoutingTable::CSimpleRoutingTable()
{

}

CSimpleRoutingTable::~CSimpleRoutingTable()
{

}

int CSimpleRoutingTable::GetDevice(int nDestination)
{
	CRoute oRoute;
	oRoute.nOutputDevice = 0;
	m_oRoutingTable.MoveFirst();
	while (!m_oRoutingTable.EOL())
	{
		oRoute = m_oRoutingTable.GetNext();
		if (oRoute.nDestination == nDestination)
		{
			return oRoute.nOutputDevice;
		}
	}
	return -1;
}

void CSimpleRoutingTable::SetRoute(int nDestination, int nDevice, int nPriority)
{
	CRoute oRoute;
	oRoute.nDestination  = nDestination;
	oRoute.nOutputDevice = nDevice;
	oRoute.nPriority     = nPriority;

	m_oRoutingTable.MoveFirst();
	while (!m_oRoutingTable.EOL())
	{
		if (oRoute.nDestination == m_oRoutingTable.GetNext().nDestination)
		{
			m_oRoutingTable.RemoveCurrent();
			break;
		}
	}
	m_oRoutingTable.AddTail(oRoute);
}

void CSimpleRoutingTable::Reset()
{
	m_oRoutingTable.RemoveAll();
}