// SinglePathRouter.cpp: implementation of the CSinglePathRouter class.
//
//////////////////////////////////////////////////////////////////////

#include "SinglePathRouter.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSinglePathRouter::CSinglePathRouter(string sLabel):CStoreAndForwardRepeater(sLabel)
{
	m_sLabel = sLabel;
	m_oEth0.ConnectToSystem(&m_oRouteSelector, 0);
	m_oEth1.ConnectToSystem(&m_oRouteSelector, 0);
	m_oEth2.ConnectToSystem(&m_oRouteSelector, 0);
	m_oEth0Queue.ConnectToSink(&m_oEth0Sink, 0);
	m_oEth1Queue.ConnectToSink(&m_oEth1Sink, 0);
	m_oEth2Queue.ConnectToSink(&m_oEth2Sink, 0);
	m_oRouteSelector.ConnectToDevice(&m_oEth0Queue,0,0);
	m_oRouteSelector.ConnectToDevice(&m_oEth1Queue,0,1);
	m_oRouteSelector.ConnectToDevice(&m_oEth2Queue,0,2);
	m_oEth0.ConnectToQueue(&m_oEth0Queue, 1);
	m_oEth1.ConnectToQueue(&m_oEth1Queue, 1);
	m_oEth2.ConnectToQueue(&m_oEth1Queue, 1);
	m_oEth0.SetParent(m_sLabel);
	m_oEth1.SetParent(m_sLabel);
	m_oEth2.SetParent(m_sLabel);
	m_oEth0.SetLabel("Eth0");
	m_oEth1.SetLabel("Eth1");
	m_oEth2.SetLabel("Eth2");
	m_oRouteSelector.ConnectToSink(&m_oBadRouteSink, 0);
}

CSinglePathRouter::~CSinglePathRouter()
{

}

bool CSinglePathRouter::LinkToDevice(CLink* pLink, int nDevice)
{
	if (nDevice == 0)
	{
		return pLink->ConnectToDevice(&m_oEth0, 0);
	}
	else if (nDevice == 1)
	{
		return pLink->ConnectToDevice(&m_oEth1, 0);
	}
	else
	{
		LOG("CSinglePathRouter::LinkToDevice");
		return false;
	}
}

bool CSinglePathRouter::LinkFromDevice(CLink* pLink, int nDevice)
{
	if (nDevice == 0)
	{
		pLink->ConnectFromDevice(&m_oEth0);
		return m_oEth0.ConnectToNetwork(pLink, 0);
	}
	else if (nDevice == 1)
	{
		pLink->ConnectFromDevice(&m_oEth1);
		return m_oEth1.ConnectToNetwork(pLink, 0);
	}
	else
	{
		LOG("CSinglePathRouter::LinkFromDevice");
		return false;
	}
}

void CSinglePathRouter::SetRoute(int nDestination, int nDevice, int nPriority)
{
	m_oRouteSelector.SetRoute(nDestination, nDevice, nPriority);
}

