// SinglePathRouter.h: interface for the CSinglePathRouter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SINGLEPATHROUTER_H__17816E0B_8D1E_415B_9D57_CC3049A5C6BF__INCLUDED_)
#define AFX_SINGLEPATHROUTER_H__17816E0B_8D1E_415B_9D57_CC3049A5C6BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "StoreAndForwardRepeater.h"
#include "RouteSelector.h"

class CSinglePathRouter : public CStoreAndForwardRepeater  
{
public:
	CSinglePathRouter(string sLabel = "Unlabeled");
	virtual ~CSinglePathRouter();

	bool LinkToDevice(CLink* pLink, int nDevice);
	bool LinkFromDevice(CLink* pLink, int nDevice);
	void SetRoute(int nDestination, int nDevice, int nPriority = 0);
	
protected:

	CEthernetDevice m_oEth0;
	CEthernetDevice m_oEth1;
	CEthernetDevice m_oEth2;
	CDropTailQueue  m_oEth0Queue;
	CDropTailQueue  m_oEth1Queue;
	CDropTailQueue  m_oEth2Queue;
	CPacketSink     m_oEth0Sink;
	CPacketSink     m_oEth1Sink;
	CPacketSink     m_oEth2Sink;
	CRouteSelector  m_oRouteSelector;
	CPacketSink		m_oBadRouteSink;

};

#endif // !defined(AFX_SINGLEPATHROUTER_H__17816E0B_8D1E_415B_9D57_CC3049A5C6BF__INCLUDED_)
