// StoreAndForwardRepeater.cpp: implementation of the CStoreAndForwardRepeater class.
//
//////////////////////////////////////////////////////////////////////

#include "StoreAndForwardRepeater.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStoreAndForwardRepeater::CStoreAndForwardRepeater(string sLabel, int nNetAddress):CComponent(sLabel, nNetAddress)
{
	m_sLabel = sLabel;
	m_oEth0.ConnectToSystem(&m_oEth1Queue, 0);
	m_oEth1.ConnectToSystem(&m_oEth0Queue, 0);
	m_oEth0Queue.ConnectToSink(&m_oEth0Sink, 0);
	m_oEth1Queue.ConnectToSink(&m_oEth1Sink, 0);
	m_oEth0.ConnectToQueue(&m_oEth0Queue, 1);
	m_oEth1.ConnectToQueue(&m_oEth1Queue, 1);
	m_oEth0.SetParentLabel(m_sLabel);
	m_oEth1.SetParentLabel(m_sLabel);
	m_oEth0.SetLabel("Eth0");
	m_oEth1.SetLabel("Eth1");

	m_oEth0Sink.SetParentAddress(m_nNetAddress);
	m_oEth1Sink.SetParentAddress(m_nNetAddress);

	
}

CStoreAndForwardRepeater::~CStoreAndForwardRepeater()
{

}

bool CStoreAndForwardRepeater::LinkToDevice(CLink* pLink, int nDevice)
{
	if (nDevice == 0)
	{
		return pLink->ConnectToDevice(&m_oEth0, 0);
	}
	else if (nDevice == 1)
	{
		return pLink->ConnectToDevice(&m_oEth1, 0);
	}
	else
	{
		LOG("CStoreAndForwardRepeater::LinkToDevice");
		return false;
	}
}

bool CStoreAndForwardRepeater::LinkFromDevice(CLink* pLink, int nDevice)
{
	if (nDevice == 0)
	{
		pLink->ConnectFromDevice(&m_oEth0);
		return m_oEth0.ConnectToNetwork(pLink, 0);
	}
	else if (nDevice == 1)
	{
		pLink->ConnectFromDevice(&m_oEth1);
		return m_oEth1.ConnectToNetwork(pLink, 0);
	}
	else
	{
		LOG("CStoreAndForwardRepeater::LinkFromDevice");
		return false;
	}
}
