// StoreAndForwardRepeater.h: interface for the CStoreAndForwardRepeater class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(STOREANDFORWARDREPEATER_H)
#define STOREANDFORWARDREPEATER_H

#include "Component.h"
#include "PacketSink.h"
#include "DropTailQueue.h"
#include "EthernetDevice.h"
#include "Link.h"

class CStoreAndForwardRepeater : public CComponent  
{
public:
	CStoreAndForwardRepeater(string sLabel = "Unlabeled", int nNetAddress = -1);
	virtual ~CStoreAndForwardRepeater();

	bool LinkToDevice(CLink* pLink, int nDevice);
	bool LinkFromDevice(CLink* pLink, int nDevice);
	



	
protected:

	CEthernetDevice m_oEth0;
	CEthernetDevice m_oEth1;
	CDropTailQueue  m_oEth0Queue;
	CDropTailQueue  m_oEth1Queue;
	CPacketSink     m_oEth0Sink;
	CPacketSink     m_oEth1Sink;


};

#endif 
