// TCPDestinationComponent.cpp: implementation of the CTCPDestinationComponent class.
//
//////////////////////////////////////////////////////////////////////

#include "TCPDestinationComponent.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTCPDestinationComponent::CTCPDestinationComponent(string sLabel, int nNumberOfDevices, int nNetAddress):CDestinationComponent(sLabel, nNumberOfDevices, nNetAddress)
{
	m_oTCPSink.resize(nNumberOfDevices);
	m_oEthQueue.resize(nNumberOfDevices);
		
	for (int i = 0; i < nNumberOfDevices; i++)
	{

		m_oEth[i].ConnectToSystem(&m_oTCPSink[i],0);	
		m_oEth[i].ConnectToQueue(&m_oEthQueue[i], 1);
		m_oEth[i].SetParentLabel(m_sLabel);
		m_oEth[i].SetParentAddress(m_nNetAddress);
		m_oEth[i].SetLabel("Eth" + str(i));
		
		m_oTCPSink[i].ConnectToNetwork(&m_oEthQueue[i],0);
		m_oTCPSink[i].SetParentLabel(m_sLabel);
		m_oTCPSink[i].SetLabel("Sink" + str(i));
		m_oTCPSink[i].SetParentAddress(m_nNetAddress);
		m_oTCPSink[i].Reset();
		
	}
}

CTCPDestinationComponent::~CTCPDestinationComponent()
{

}

bool CTCPDestinationComponent::LinkFromDevice(CLink* pLink, int nDevice)
{
	if (nDevice < m_nNumberOfDevices)
	{
		pLink->ConnectFromDevice(&m_oEth[nDevice]);
		return m_oEth[nDevice].ConnectToNetwork(pLink, 0);
	}
	else
	{
		LOG("CTCPDestinationComponent::LinkFromDevice");
		return false;
	}
}


void CTCPDestinationComponent::Report()
{

}


