// TCPPRSource.cpp: implementation of the CTCPPRSource class.
//
//////////////////////////////////////////////////////////////////////

#include "TCPPRSource.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTCPPRSource::CTCPPRSource(string sLabel, int nSourceAddress, int nDestinationAddress, int nSize):CTCPSource(sLabel, nSourceAddress, nDestinationAddress, nSize)
{

}

CTCPPRSource::~CTCPPRSource()
{

}

bool CTCPPRSource::AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel)
{
	if (((pIncommingPacket->Type() == ACK) && (pIncommingPacket->SessionID() == m_nSessionID)) ||
		((pIncommingPacket->Type() == DUPACK) && (pIncommingPacket->SessionID() == m_nSessionID)))
	{
		
		m_nAckCount++;
		if (m_nAckCount >= ACK_THRESH)
		{
			m_nDropCount = 0;
			m_nAckCount = 0;
			m_nWindowSize = max(min(m_nWindowSize + 1, m_nMaxWindowSize),1);
		}
		m_vPackets[pIncommingPacket->Data()]->SetAcknowledged(true);
		delete pIncommingPacket;
		while (m_vPackets[m_nLowestAck + 1]->Acknowledged())
		{
			if (m_nLowestAck < m_nTotalPackets)
			{
				m_nLowestAck++;
				m_nWindowStart++;
				if (m_nLowestAck == m_nTotalPackets)
				{
					reset();
					return true;
				}
			}
		}
	}
	else
	{
		delete pIncommingPacket;
	}
	return true;
}
