// TCPSource.h: interface for the CTCPSource class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(TCPSOURCE_H)
#define TCPSOURCE_H

#include "Element.h"
#include <vector>
#include "PushConnection.h"

class CTCPSource : public CElement  
{
public:
	CTCPSource(string sLabel = "Unlabeled", int nSourceAddress = 0, int nDestinationAddress = 0, int nSize = MAX_TCPWINDOW);
	virtual ~CTCPSource();
	bool ConnectToNetwork(CElement* pElement, int nLabel);
	void GenerateFile(int nFileSize = 10000);
	bool AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel);
	void Go();
	bool Done();
	void SetSource(int nSourceAddress);
	void SetDestination(int nDestinationAddress);
	int TotalTime();
	
protected:
	void fastRetransmit();

	int m_nWindowSize;
	int m_nMaxWindowSize;
	vector<CPacket*> m_vPackets;
	int m_nWindowStart;
	int m_nLowestAck;
	bool m_bProcessingFile;
	CPushConnection m_oNetwork;
	int m_nSessionID;
	int m_nDestination;
	int m_nTotalPackets;
	int m_nDropCount;
	int m_nAckCount;
	int m_nSourceAddress;
	int m_nTotalTime;
	int m_nDupCount;

	void reset();
};

#endif 
