// TCPTrafficGenerator.h: interface for the CTCPTrafficGenerator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(TCPTRAFFICGENERATOR_H)
#define TCPTRAFFICGENERATOR_H

#include "Component.h"
#include "DropTailQueue.h"
#include "TCPSource.h"
#include "PacketSink.h"
#include "TCPPRSource.h"

class CTCPTrafficGenerator : public CComponent  
{
public:
	CTCPTrafficGenerator(string sLabel = "Unlabeled", int nSourceAddress = 0, int nDestinationAddress = 0, int nType = 0);
	virtual ~CTCPTrafficGenerator();

	bool LinkFromDevice(CLink* pLink, int nDevice);
	bool LinkToDevice(CLink* pLink, int nDevice);
	void Go();
	void GenerateFile(int nFileSize = 10000);
	bool Done();
	void Report();

protected:
	CEthernetDevice m_oEth0;
	CDropTailQueue m_oEth0Queue;
	CTCPSource* m_pTCPSource;
	CPacketSink m_oEth0Sink;
	double m_nTotalTime;
	int m_nFileSize;
};

#endif 
