// WTPDropTailQueue.cpp: implementation of the CWTPDropTailQueue class.
//
//////////////////////////////////////////////////////////////////////

#include "WTPDropTailQueue.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWTPDropTailQueue::CWTPDropTailQueue(int nCapacity, int nWeight) : CWeightedDropTailQueue(nCapacity, nWeight)
{
	m_nTimer = 0;
}

CWTPDropTailQueue::~CWTPDropTailQueue()
{

}

void CWTPDropTailQueue::IncrementTime()
{
	m_nTimer++;
}

bool CWTPDropTailQueue::AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel)
{
	pIncommingPacket->SetTimeInQueue(m_nTimer);
	return CDropTailQueue::AcceptPacket(pIncommingPacket, nConnectionLabel);
}

int CWTPDropTailQueue::QueuePriority()
{
	if (!m_PacketQueue.EOL())
	{
		int nWaitTime = m_nTimer - m_PacketQueue.GetHead()->TimeInQueue();
		return m_nWeight * nWaitTime;
	}
	else
	{
		return 0;
	}
}

void CWTPDropTailQueue::Go()
{
	m_nTimer++;
}
