// WTPScheduler.h: interface for the CWTPScheduler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WTPSCHEDULER_H__28AE02D3_2B23_43D8_B696_18A2B9E558B5__INCLUDED_)
#define AFX_WTPSCHEDULER_H__28AE02D3_2B23_43D8_B696_18A2B9E558B5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Element.h"
#include "PacketClassifier.h"
#include "WTPDropTailQueue.h"
#include "DynamicPriorityScheduler.h"
#include <vector>
#include <math.h>

class CWTPScheduler : public CElement  
{
public:
	CWTPScheduler(int nNumberOfClasses = 4);
	virtual ~CWTPScheduler();
	bool ConnectToSink(CElement* pElement, int nLabel);
	bool AcceptPacket(CPacket* pIncommingPacket, int nConnectionLabel);
	CPacket* GetPacket(int nConnectionLabel);
	int BackPressure();
	void Go();
	bool Done();
	void SetNumberOfClasses(int nNumberOfClasses);

protected:
	
	CPacketClassifier m_oClassifier;
	vector<CWTPDropTailQueue> m_vQueue;
	CDynamicPriorityScheduler m_oScheduler;
	int m_nNumberOfClasses;


};

#endif // !defined(AFX_WTPSCHEDULER_H__28AE02D3_2B23_43D8_B696_18A2B9E558B5__INCLUDED_)
