#include "Link.h"
#include "PacketGenerator.h"
#include "StoreAndForwardRepeater.h"
#include "DestinationComponent.h"
#include "TCPDestinationComponent.h"
#include "Router.h"
#include "TCPSource.h"
#include "TCPTrafficGenerator.h"
#include "WTPRepeater.h"
#include "DataCollectionComponent.h"

void ConnectDevices(CComponent& oSourceDevice, CComponent& oDestinationDevice, CLink* pOutLink, CLink* oInLink, int nSourceDevice, int nDestinationDevise);

int main ( void )
{
	const int NUM_OF_LINKS = 1;
	//1 Traffic Generators
	CPacketGenerator oSource1(50,10,200);

	//1 Repeater
	CWTPRepeater oRepeater("Repeater1", 3);
	
	//1 Sinks
	CDataCollectionComponent oSink1("Sink1", 1, 1);

	//1 OutBound Links
	CLink oOutLink;

	oOutLink.SetConnectionSpeed(300);
	
	//Make Connections
	//Destination.LinkToDevice(Source)
	//Source.LinkFrom(Destination)
	
	oSink1.LinkToDevice(&oOutLink,0);
	oRepeater.LinkFromDevice(&oOutLink,1);
	oRepeater.LinkToDevice(&oSource1,0);




	while (!(oSource1.Done() && oRepeater.Done()))
	{
		oSource1.Go();
		oRepeater.Go();
		oOutLink.Go();
		oSink1.Go();
			
	}
	
	oSink1.Report();
	return 0;
}

void ConnectDevices(CComponent & oSourceDevice, CComponent & oDestinationDevice, CLink* pOutLink, CLink * pInLink, int nSourceDevice, int nDestinationDevice)
{
	oSourceDevice.LinkToDevice(pInLink,nSourceDevice);
	oSourceDevice.LinkFromDevice(pOutLink,nSourceDevice);

	oDestinationDevice.LinkToDevice(pOutLink,nDestinationDevice);
	oDestinationDevice.LinkFromDevice(pInLink,nDestinationDevice);
}

